$(document).ready(function () {
    // hovered();

    //initial state on load
    $('#filter').val('');

    $("#btn_uncheckAll").show();
    check_show_all();

    $('#btn_uncheckAll').click(function () {
        var clicked = $(this);
        if (! $(this).is(':checked')) {
            $("#btn_checkAll").show();
            uncheck_hide_all();
            $("#btn_uncheckAll").hide();
            $('#filter').val('');
            reapplyStripes();
        } else {
            reapplyStripes();
        }
    });

    $('#btn_checkAll').click(function () {
        var clicked = $(this);
        if (! $(this).is(':checked')) {
            $("#btn_checkAll").hide();
            check_show_all();
            $("#btn_uncheckAll").show();
            $('#filter').val('');
            reapplyStripes();
        } else {
            reapplyStripes();
        }
    });

    $("table#resultTable tr:even td").addClass("even");

    //filtering on all columns and rows
    $('#filter').keyup(function (event) {
        //if esc is pressed or nothing is entered
        if (event.keyCode == 27 || $(this).val() == '') {
            //if esc is pressed we want to clear the value of search box
            $(this).val('');
            filtertable('#resultTable tbody tr', $(this).val());
            //we want each row to be visible because if nothing
            //is entered then all rows are matched.
            //$('#resultTable tbody tr').removeClass('visible').show().addClass('visible');
        } else {
            filtertable('#resultTable tbody tr', $(this).val());
            all_checked();
            $("#btn_checkAll").hide();
            $("#btn_uncheckAll").show();
            reapplyStripes();
        }
        reapplyStripes();
    });

    //sorting all columns: grab all header rows
    $('table#resultTable > thead > tr > th').each(function (column) {
        $(this).addClass('sortable').click(function () {
            $("table#resultTable tr td").removeClass("even");

            //var spinner =  new Spinner().spin($("table").get(0));

            var findSortKey = function ($cell) {
                return $cell.find('.sort-key').text().toUpperCase() + ' ' + $cell.text().toUpperCase();
            };

            var sortDirection = $(this).is('.sorted-asc') ? 1: -1;
            var sortDirection1 = $(this).is('.sorted-asc') ? -1: 1;

            //step back up the tree and get the rows with data
            //for sorting
            var $rows = $(this).closest('table').find('tbody > tr').get();

            //loop through all the rows and find
            $.each($rows, function (index, row) {
                row.sortKey = findSortKey($(row).children('td').eq(column));
            });

            //compare and sort the rows alphabetically
            $rows.sort(function (a, b) {
                if (a.sortKey < b.sortKey) return - sortDirection;
                if (a.sortKey > b.sortKey) return sortDirection;
                return 0;
            });

            //add the rows in the correct order to the bottom of the table
            $.each($rows, function (index, row) {
                $('table#resultTable > tbody').append(row);
                row.sortKey = null;
            });

            //identify the column sort order
            $('table#resultTable > thead > tr > th').removeClass('sorted-asc sorted-desc');
            var $sortHead = $('th').filter(':nth-child(' + (column + 1) + ')');
            sortDirection == 1 ? $sortHead.addClass('sorted-desc'): $sortHead.addClass('sorted-asc');

            //identify the column to be sorted by
            $('table#resultTable > tbody > tr > td').removeClass('sorted').filter(':nth-child(' + (column + 1) + ')').addClass('sorted');

            reapplyStripes();
        });
    });

    // Reset Filter button
    resetFilter();

    // Filter checked languages
    filter_checked_langs();

    // Hide Table button
    //hideTable();

    // Show Table button
    //showTable();

    // Applying zebra stripes
    $('table#resultTable thead tr th').removeClass('clicked').addClass('clicked');
});

function resetFilter() {
    $("input#btn_refresh_table").click(function () {
        $('#filter').val('');
        all_checked();
        show_all();
        $("#btn_checkAll").hide();
        $("#btn_uncheckAll").show();
        reapplyStripes();
    });
}

/*function hideTable() {
$("#btn_toggle_table_hide").click(function () {
$('#resultTable').toggle();
$("#btn_toggle_table_hide").toggle();
var clicked = $(this);
clicked.removeClass("selected").addClass("unselected");
$("#btn_toggle_table_show").toggle();
});
}

function showTable() {
$("#btn_toggle_table_show").click(function () {
$('#resultTable').toggle();
$("#btn_toggle_table_show").toggle();
var clicked = $(this);
clicked.removeClass("selected").addClass("unselected");
$("#btn_toggle_table_hide").toggle();
reapplyStripes();
});
}*/

//testing hovered function
function hovered() {
    $('table tbody tr').hover(function () {
        $(this).find('td').addClass('hovered');
        $(this).find('a').addClass('hovered');
        $(this).find('td.admonition').removeClass('hovered');
        $(this).find('a.admonition').removeClass('hovered');
    },
    function () {
        $(this).find('td').removeClass('hovered');
        $(this).find('a').removeClass('hovered');
    });

    $('table thead tr th').hover(function () {
        $(this).addClass('hovered');
        $(this).find('a').addClass('hovered');
        $(this).find('th.admonition').removeClass('hovered');
        $(this).find('a.admonition').removeClass('hovered');
    },
    function () {
        $(this).removeClass('hovered');
        $(this).find('a').removeClass('hovered');
    });
}

//used to apply alternating row styles
function zebraRows(selector, className) {
    $(selector).removeClass(className).addClass(className);
}

//reapply zebra rows
function reapplyStripes() {
    $('table#resultTable tr td').removeClass('even');
    zebraRows('table#resultTable tr:visible:even td', 'even');
}

// filter results based on query
function filtertable(selector, query) {
    query = $.trim(query);
    //trim white space
    query = query.replace(/ /gi, '|');
    //add OR for regex query

    $(selector).each(function () {
        ($(this).text().search(new RegExp(query, "i")) < 0) ? $(this).hide().removeClass('visible'): $(this).show().addClass('visible');
    });
}

// helper method called by filter_checked_langs()
function show_hide_langs_with_filters(rowID, lang, result) {
    $(row).click(function () {
        if (! $(this).is(':checked')) {
            lang.hide();
            reapplyStripes();
        } else {
            reapplyStripes();
        }
        reapplyStripes();
    });
}
// show or hide rows containing langs depending on whether the lang checkbox is checked
function filter_checked_langs() {
    show_hide_langs_with_filters('#ck_c_cpp', $('tr:contains("  C/C++  ")'), '#resultTable tbody tr:contains("  C/C++  ")');
    show_hide_langs_with_filters('#ck_csharp', $('tr:contains("  C#  ")'), '#resultTable tbody tr:contains("  C#  ")');
    show_hide_langs_with_filters('#ck_cuda', $('tr:contains("  CUDA  ")'), '#resultTable tbody tr:contains("  CUDA  ")');
    show_hide_langs_with_filters('#ck_golang', $('tr:contains("  Go  ")'), '#resultTable tbody tr:contains("  Go  ")');
    show_hide_langs_with_filters('#ck_java', $('tr:contains("  Java  ")'), '#resultTable tbody tr:contains("  Java  ")');
    show_hide_langs_with_filters('#ck_javascript', $('tr:contains("  JavaScript  ")'), '#resultTable tbody tr:contains("  JavaScript  ")');
    show_hide_langs_with_filters('#ck_kotlin', $('tr:contains("  Kotlin  ")'), '#resultTable tbody tr:contains("  Kotlin  ")');
    show_hide_langs_with_filters('#ck_obj-c_cpp', $('tr:contains("  Objective-C/C++  ")'), '#resultTable tbody tr:contains("  Objective-C/C++  ")');
    show_hide_langs_with_filters('#ck_php', $('tr:contains("  PHP  ")'), '#resultTable tbody tr:contains("  PHP  ")');
    show_hide_langs_with_filters('#ck_python', $('tr:contains("  Python  ")'), '#resultTable tbody tr:contains("  Python  ")');
    show_hide_langs_with_filters('#ck_ruby', $('tr:contains("  Ruby  ")'), '#resultTable tbody tr:contains("  Ruby  ")');
    show_hide_langs_with_filters('#ck_swift', $('tr:contains("  Swift  ")'), '#resultTable tbody tr:contains("  Swift  ")');
    show_hide_langs_with_filters('#ck_text', $('tr:contains("  Text  ")'), '#resultTable tbody tr:contains("  Text  ")');
    show_hide_langs_with_filters('#ck_fortran', $('tr:contains("  Fortran  ")'), '#resultTable tbody tr:contains("  Fortran  ")');
    show_hide_langs_with_filters('#ck_scala', $('tr:contains("  Scala  ")'), '#resultTable tbody tr:contains("  Scala  ")');
    show_hide_langs_with_filters('#ck_typescript', $('tr:contains("  TypeScript  ")'), '#resultTable tbody tr:contains("  TypeScript  ")');
    show_hide_langs_with_filters('#ck_vb', $('tr:contains("  Visual Basic  ")'), '#resultTable tbody tr:contains("  Visual Basic  ")');
}


// helper method called by filter_checked_langs()
function show_hide_langs(row, lang, result) {
    $(row).click(function () {
        if (! $(this).is(':checked')) {
            lang.hide();
            $("#btn_checkAll").show();
            hide_uncheck_all();
            reapplyStripes();
        } else {
            lang.show();
            filtertable(result, $('#filter').val());
            $("#btn_uncheckAll").show();
            hide_check_all();
            reapplyStripes();
        }
        reapplyStripes();
    });
}

/*function show_check_all_btn() {
if (all_unchecked()) {
$("#btn_checkAll").show();
$("#btn_uncheckAll").hide();
} else {
filter_checked_langs();
}
}*/

// show or hide rows containing langs depending on whether the lang checkbox is checked
function filter_checked_langs() {
    show_hide_langs('#ck_c_cpp', $('tr:contains("  C/C++  ")'), '#resultTable tbody tr:contains("  C/C++  ")');
    show_hide_langs('#ck_csharp', $('tr:contains("  C#  ")'), '#resultTable tbody tr:contains("  C#  ")');
    show_hide_langs('#ck_cuda', $('tr:contains("  CUDA  ")'), '#resultTable tbody tr:contains("  CUDA  ")');
    show_hide_langs('#ck_golang', $('tr:contains("  Go  ")'), '#resultTable tbody tr:contains("  Go  ")');
    show_hide_langs('#ck_java', $('tr:contains("  Java  ")'), '#resultTable tbody tr:contains("  Java  ")');
    show_hide_langs('#ck_javascript', $('tr:contains("  JavaScript  ")'), '#resultTable tbody tr:contains("  JavaScript  ")');
    show_hide_langs('#ck_kotlin', $('tr:contains("  Kotlin  ")'), '#resultTable tbody tr:contains("  Kotlin  ")');
    show_hide_langs('#ck_obj-c_cpp', $('tr:contains("  Objective-C/C++  ")'), '#resultTable tbody tr:contains("  Objective-C/C++  ")');
    show_hide_langs('#ck_php', $('tr:contains("  PHP  ")'), '#resultTable tbody tr:contains("  PHP  ")');
    show_hide_langs('#ck_python', $('tr:contains("  Python  ")'), '#resultTable tbody tr:contains("  Python  ")');
    show_hide_langs('#ck_ruby', $('tr:contains("  Ruby  ")'), '#resultTable tbody tr:contains("  Ruby  ")');
    show_hide_langs('#ck_swift', $('tr:contains("  Swift  ")'), '#resultTable tbody tr:contains("  Swift  ")');
    show_hide_langs('#ck_text', $('tr:contains("  Text  ")'), '#resultTable tbody tr:contains("  Text  ")');
    show_hide_langs('#ck_fortran', $('tr:contains("  Fortran  ")'), '#resultTable tbody tr:contains("  Fortran  ")');
    show_hide_langs('#ck_scala', $('tr:contains("  Scala  ")'), '#resultTable tbody tr:contains("  Scala  ")');
    show_hide_langs('#ck_typescript', $('tr:contains("  TypeScript  ")'), '#resultTable tbody tr:contains("  TypeScript  ")');
    show_hide_langs('#ck_vb', $('tr:contains("  Visual Basic  ")'), '#resultTable tbody tr:contains("  Visual Basic  ")');
}

// if all lang boxes unchecked, show the check all button
function hide_uncheck_all() {
    if (! $('#ck_c_cpp').is(':checked') && ! $('#ck_csharp').is(':checked') && ! $('#ck_cuda').is(':checked') && ! $('#ck_golang').is(':checked') && ! $('#ck_java').is(':checked') && ! $('#ck_javascript').is(':checked') && ! $('#ck_kotlin').is(':checked')&& ! $('#ck_obj-c_cpp').is(':checked') && ! $('#ck_php').is(':checked') && ! $('#ck_python').is(':checked') && ! $('#ck_ruby').is(':checked') && ! $('#ck_swift').is(':checked') && ! $('#ck_text').is(':checked') && ! $('#ck_fortran').is(':checked') && ! $('#ck_scala').is(':checked') && ! $('#ck_typescript').is(':checked') && ! $('#ck_vb').is(':checked')) {
        $("#btn_uncheckAll").hide();
        $("#btn_checkAll").show();
        $('#filter').val('');
        reapplyStripes();
    } else {
        $("#btn_uncheckAll").show();
        reapplyStripes();
    }
}

// if all lang boxes checked, hide the check all button
function hide_check_all() {
    if ($('#ck_c_cpp').is(':checked') && $('#ck_csharp').is(':checked') && $('#ck_cuda').is(':checked') && $('#ck_golang').is(':checked') && $('#ck_java').is(':checked') && $('#ck_javascript').is(':checked') && $('#ck_kotlin').is(':checked') && $('#ck_obj-c_cpp').is(':checked') && $('#ck_php').is(':checked') && $('#ck_python').is(':checked') && $('#ck_ruby').is(':checked') && $('#ck_swift').is(':checked') && $('#ck_text').is(':checked') && $('#ck_fortran').is(':checked') && $('#ck_scala').is(':checked') && $('#ck_typescript').is(':checked')  && $('#ck_vb').is(':checked')) {
        $("#btn_checkAll").hide();
        $("#btn_uncheckAll").show();
        reapplyStripes();
    } else {
        $("#btn_checkAll").show();
        reapplyStripes();
    }
}

// uncheck all lang checkboxes
function all_checked() {
    $('#ck_c_cpp').prop('checked', true);
    $('#ck_csharp').prop('checked', true);
    $('#ck_cuda').prop('checked', true);
    $('#ck_golang').prop('checked', true);
    $('#ck_java').prop('checked', true);
    $('#ck_javascript').prop('checked', true);
    $('#ck_kotlin').prop('checked', true);
    $('#ck_obj-c_cpp').prop('checked', true);
    $('#ck_php').prop('checked', true);
    $('#ck_python').prop('checked', true);
    $('#ck_ruby').prop('checked', true);
    $('#ck_swift').prop('checked', true);
    $('#ck_text').prop('checked', true);
    $('#ck_fortran').prop('checked', true);
    $('#ck_scala').prop('checked', true);
    $('#ck_typescript').prop('checked', true);
    $('#ck_vb').prop('checked', true);
}

// hide all langs
function hide_all() {
    $('tr:contains("  C/C++  ")').hide();
    $('tr:contains("  C#  ")').hide();
    $('tr:contains("  CUDA  ")').hide();
    $('tr:contains("  Go  ")').hide();
    $('tr:contains("  Java  ")').hide();
    $('tr:contains("  JavaScript  ")').hide();
    $('tr:contains("  Kotlin  ")').hide();
    $('tr:contains("  Objective-C/C++  ")').hide();
    $('tr:contains("  PHP  ")').hide();
    $('tr:contains("  Python  ")').hide();
    $('tr:contains("  Ruby  ")').hide();
    $('tr:contains("  Swift  ")').hide();
    $('tr:contains("  Text  ")').hide();
    $('tr:contains("  Fortran  ")').hide();
    $('tr:contains("  Scala  ")').hide();
    $('tr:contains("  TypeScript  ")').hide();
    $('tr:contains("  Visual Basic  ")').hide();
}

// hide all langs and uncheck all lang checkboxes
function uncheck_hide_all() {
    hide_all();
    all_unchecked();
}

// show all langs
function show_all() {
    $('tr:contains("  C/C++  ")').show();
    $('tr:contains("  C#  ")').show();
    $('tr:contains("  CUDA  ")').show();
    $('tr:contains("  Go  ")').show();
    $('tr:contains("  Java  ")').show();
    $('tr:contains("  JavaScript  ")').show();
    $('tr:contains("  Kotlin  ")').show();
    $('tr:contains("  Objective-C/C++  ")').show();
    $('tr:contains("  PHP  ")').show();
    $('tr:contains("  Python  ")').show();
    $('tr:contains("  Ruby  ")').show();
    $('tr:contains("  Swift  ")').show();
    $('tr:contains("  Text  ")').show();
    $('tr:contains("  Fortran  ")').show();
    $('tr:contains("  Scala  ")').show();
    $('tr:contains("  TypeScript  ")').show();
    $('tr:contains("  Visual Basic  ")').show();
}

// show all langs and check all lang checkboxes
function check_show_all() {
    show_all();
    all_checked();
}

// uncheck all lang checkboxes
function all_unchecked() {
    $('#ck_c_cpp').prop('checked', false)
    $('#ck_csharp').prop('checked', false)
    $('#ck_cuda').prop('checked', false)
    $('#ck_golang').prop('checked', false)
    $('#ck_java').prop('checked', false)
    $('#ck_javascript').prop('checked', false)
    $('#ck_kotlin').prop('checked', false)
    $('#ck_obj-c_cpp').prop('checked', false)
    $('#ck_php').prop('checked', false)
    $('#ck_python').prop('checked', false)
    $('#ck_ruby').prop('checked', false)
    $('#ck_swift').prop('checked', false)
    $('#ck_text').prop('checked', false)
    $('#ck_fortran').prop('checked', false)
    $('#ck_scala').prop('checked', false)
    $('#ck_typescript').prop('checked', false)
    $('#ck_vb').prop('checked', false)
}
